<?php

# check if session is valid
$newTarget = '/app/berogui/index.php?m=Sip';
require_once('/usr/local/www/berogui/includes/session.php');
unset($newTarget);
/**
 * Speichert die SIP Konten
 */
chdir("../..");

include "./includes/variables.php";
require_once "./includes/Helper/Helper.php";
require_once "./includes/Helper/HelperSip.php";
include "./misc/database.php";
require_once "./includes/isgwtelnet.php";
$ba = new beroAri();

function parameters($config = "") {
	$default = Helper::getDefaultConfig();

	foreach ($_POST as $key => $value) {
		$_POST[$key] = str_replace("'", "\"", $_POST[$key]);
	}

	foreach (HelperSip::$configSave as $option) {
		if (isset($_POST[$option]) && $_POST[$option] != $default[$option]) {
			$config .= ',' . $option . '=' . $_POST[$option];
		}
	}

	//SRTP_CRYPTO_SUITES
	$c = "";
	for ($i = 0; $i < count($_POST['srtp_crypto_suites']); $i++) {
		if ($c != "") {
			$c .= ":";
		}
		$c .= $_POST['srtp_crypto_suites'][$i];
	}
	if ($c != "")
		$config .= ",srtp_crypto_suites=" . $c;

	//SIP_TO_USER_SETTING
	if (isset($_POST['sip_to_user_setting']) && $_POST['sip_to_user_setting'] != 'manual' && $_POST['sip_to_user_setting'] != $default['sip_to_user_setting']) {
		$config .= ",sip_to_user_setting=" . $_POST['sip_to_user_setting'];
	} else if (isset($_POST['sip_to_user_setting']) && $_POST['sip_to_user_setting'] == 'manual') {
		$config .= ",sip_to_user_setting=" . $_POST['sip_to_user_setting_manual'];
	}

	//SIP_FROM_USER_SETTING
	if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting'] != 'manual' && $_POST['sip_from_user_setting'] != $default['sip_from_user_setting']) {
		$config .= ",sip_from_user_setting=" . $_POST['sip_from_user_setting'];
	} else if (isset($_POST['sip_from_user_setting']) && $_POST['sip_from_user_setting'] == 'manual') {
		$config .= ",sip_from_user_setting=" . $_POST['sip_from_user_setting_manual'];
	}

	//SIP_FROM_DISPLAY_SETTING
	if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting'] != 'manual' && $_POST['sip_from_display_setting'] != $default['sip_from_display_setting']) {
		$config .= ",sip_from_display_setting=" . $_POST['sip_from_display_setting'];
	} else if (isset($_POST['sip_from_display_setting']) && $_POST['sip_from_display_setting'] == 'manual') {
		$config .= ",sip_from_display_setting=" . $_POST['sip_from_display_setting_manual'];
	}

	//SIP_PAI_USER_SETTING
	if (isset($_POST['sip_pai_user_setting']) && $_POST['sip_pai_user_setting'] != 'manual' && $_POST['sip_pai_user_setting'] != $default['sip_pai_user_setting']) {
		$config .= ",sip_pai_user_setting=" . $_POST['sip_pai_user_setting'];
	} else if (isset($_POST['sip_pai_user_setting']) && $_POST['sip_pai_user_setting'] == 'manual') {
		$config .= ",sip_pai_user_setting=" . $_POST['sip_pai_user_setting_manual'];
	}

	//SIP_PPI_USER_SETTING
	if (isset($_POST['sip_ppi_user_setting']) && $_POST['sip_ppi_user_setting'] != 'manual' && $_POST['sip_ppi_user_setting'] != $default['sip_ppi_user_setting']) {
		$config .= ",sip_ppi_user_setting=" . $_POST['sip_ppi_user_setting'];
	} else if (isset($_POST['sip_ppi_user_setting']) && $_POST['sip_ppi_user_setting'] == 'manual') {
		$config .= ",sip_ppi_user_setting=" . $_POST['sip_ppi_user_setting_manual'];
	}

	//CODECS
	$c = "";
	for ($i = 0; $i < count($_POST['codecs']); $i++) {
		if ($c != "") {
			$c .= ":";
		}
		$c .= $_POST['codecs'][$i];
	}
	if ($c != "" && $c != $default['codecs']) {
		$config .= ",codecs=" . $c;
	}


	//Additional config string hinzufügen.
	if ($_POST['addit_options'] != "")
		$config .= "," . str_replace(array("\r\n", "\n", "\r"), ",", $_POST['addit_options']);

	$config = trim($config, ",");

	return $config;
}

$name = $_POST['name'];
$sip_proxy = $_POST['sip_proxy'];
$sip_registrar = $_POST['sip_registrar'];
$sip_domain = $_POST['sip_domain'];
$user = sqlite_escape_string($_POST['user']);
$auth_user = sqlite_escape_string($_POST['auth_user']);
$displayname = sqlite_escape_string($_POST['displayname']);
if (is_array($_POST['matchtype'])) {
	foreach ($_POST['matchtype'] as $type) {
		$matchtype .= ($matchtype == "") ? "" : "|";
		$matchtype .= $type;
	}
	if (in_array('manual', $_POST['matchtype'])) {
		$matchtype_manual = $_POST['matchtype_manual'];
	}
}
$profile = sqlite_escape_string($_POST['profile']);
$secret = sqlite_escape_string($_POST['secret']);
$sip_stack = $_POST['sip_stack'];
$sip_transport = $_POST['sip_transport'];
$sip_custom_port = $_POST['sip_custom_port'];
$register = $_POST['register'];
$enum_support = $_POST['enum_support'];
$enum_search_domains = $_POST['enum_search_domains'];
$call_transfer_method = $_POST['call_transfer_method'];
if ($_POST['option'] == "stun")
	$stunserver = $_POST['stunserver'];
if ($register == 1) {
	$regrefresh = $_POST['regrefresh'];
	$register_option = $_POST['register_option'];
	$keepalive_interval = $_POST['keepalive_interval'];
} else {
	$regrefresh = "";
	$register_option = "no-validate no-options-keepalive";
	$keepalive_interval = "30";
}
if ($_POST['option'] == "externip") {
	$externip = $_POST['externip'];
}
if ($_POST['option'] == "nonat") {
	$externip = "";
	$stunserver = "";
}

$s2s_nat_opener = $_POST['s2s_nat_opener'];
$use_privacy_header = $_POST['use_privacy_header'];

$config = parameters();
$id = $_POST['id_upd'];
//After modify
if ($_POST['id_upd']) {
	$query_new = $ba->update('UPDATE sip SET name=\'' . sqlite_escape_string($name) . '\', sip_transport=\'' . sqlite_escape_string($sip_transport) . '\', '
		. 'sip_proxy=\'' . sqlite_escape_string($sip_proxy) . '\', sip_domain=\'' . sqlite_escape_string($sip_domain) . '\', '
		. 'sip_registrar=\'' . sqlite_escape_string($sip_registrar) . '\', user=\'' . sqlite_escape_string($user) . '\', '
		. 'auth_user=\'' . sqlite_escape_string($auth_user) . '\', displayname=\'' . sqlite_escape_string($displayname) . '\', '
		. 'secret=\'' . sqlite_escape_string($secret) . '\', register=\'' . sqlite_escape_string($register) . '\', '
		. 'regrefresh=\'' . sqlite_escape_string($regrefresh) . '\', register_option=\'' . sqlite_escape_string($register_option) . '\', '
		. 'config=\'' . sqlite_escape_string($config) . '\', stunserver=\'' . sqlite_escape_string($stunserver) . '\', '
		. 'externip=\'' . sqlite_escape_string($externip) . '\',  profile=\'' . sqlite_escape_string($profile) . '\', '
		. 'matchtype=\'' . sqlite_escape_string($matchtype) . '\', matchtype_manual=\'' . sqlite_escape_string($matchtype_manual) . '\', '
		. 'enum_support=\'' . sqlite_escape_string($enum_support) . '\', enum_search_domain=\'' . sqlite_escape_string($enum_search_domains) . '\', '
		. 'keepalive_interval=\'' . sqlite_escape_string($keepalive_interval) . '\', call_transfer_method=\'' . sqlite_escape_string($call_transfer_method) . '\', '
		. 'sip_custom_port=\'' . sqlite_escape_string($sip_custom_port) . '\',  sip_stack=\'' . sqlite_escape_string($sip_stack) . '\' '
		. 'WHERE id=\'' . sqlite_escape_string($id) . '\'');
	//Add new SIP account
} else {
	$query_new = $ba->insert_('INSERT INTO sip (name, sip_transport, sip_proxy, sip_registrar, sip_domain, '
		. 'user, auth_user, displayname, secret, register,  config, externip, stunserver, regrefresh, '
		. 'register_option, profile, matchtype, matchtype_manual, enum_support, enum_search_domain,'
		. ' keepalive_interval, call_transfer_method, sip_custom_port, sip_stack) '
		. 'VALUES (\'' . sqlite_escape_string($name) . '\', \'' . sqlite_escape_string($sip_transport) . '\', \'' . sqlite_escape_string($sip_proxy) . '\', '
		. '\'' . sqlite_escape_string($sip_registrar) . '\', \'' . sqlite_escape_string($sip_domain) . '\', \'' . sqlite_escape_string($user) . '\', '
		. '\'' . sqlite_escape_string($auth_user) . '\', \'' . sqlite_escape_string($displayname) . '\', \'' . sqlite_escape_string($secret) . '\', '
		. '\'' . sqlite_escape_string($register) . '\', \'' . sqlite_escape_string($config) . '\',\'' . sqlite_escape_string($externip) . '\', '
		. '\'' . sqlite_escape_string($stunserver) . '\',\'' . sqlite_escape_string($regrefresh) . '\', \'' . sqlite_escape_string($register_option) . '\', '
		. '\'' . sqlite_escape_string($profile) . '\',\'' . sqlite_escape_string($matchtype) . '\',\'' . sqlite_escape_string($matchtype_manual) . '\','
		. '\'' . sqlite_escape_string($enum_support) . '\',\'' . sqlite_escape_string($enum_search_domains) . '\', \'' . sqlite_escape_string($keepalive_interval) . '\','
		. '\'' . sqlite_escape_string($call_transfer_method) . '\', \'' . sqlite_escape_string($sip_custom_port) . '\', \'' . sqlite_escape_string($sip_stack) . '\')');
}
if (!$ba->is_error() && $_POST['id_upd']) {
	$query = $ba->update("UPDATE dialplan SET fromId='p:" . sqlite_escape_string($name) . "'
						where fromDirection='sip' and fromId='p:" . sqlite_escape_string($_POST['alt_name']) . "'");
	$query = $ba->update("UPDATE dialplan SET toId='p:" . sqlite_escape_string($name) . "'
						where toDirection='sip' and toId='p:" . sqlite_escape_string($_POST['alt_name']) . "'");
	$query = $ba->update("UPDATE dialplan SET fromId='d:" . sqlite_escape_string($name) . "'
						where fromDirection='sip' and fromId='d:" . sqlite_escape_string($_POST['alt_name']) . "'");
	$query = $ba->update("UPDATE dialplan SET fromId='t:" . sqlite_escape_string($name) . "'
						where fromDirection='sip' and fromId='t:" . sqlite_escape_string($_POST['alt_name']) . "'");
	$query = $ba->update("UPDATE dialplan SET fromId='a:" . sqlite_escape_string($name) . "'
						where fromDirection='sip' and fromId='a:" . sqlite_escape_string($_POST['alt_name']) . "'");
}
Helper::activate(1);
if (!$ba->is_error()) {
	echo "<script>window.location='../../index.php?m=Sip'</script>";
} else {
	echo "<script>alert('" . $ba->error() . "');</script>";
}
